"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnergyTransferRequestPostgresRepository = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const EnergyTransferRequest_1 = require("../EnergyTransferRequest");
const EnergyTransferRequest_entity_1 = require("./EnergyTransferRequest.entity");
let EnergyTransferRequestPostgresRepository = class EnergyTransferRequestPostgresRepository {
    constructor(repository, connection) {
        this.repository = repository;
        this.connection = connection;
    }
    async save(entity) {
        await this.repository.update({ id: entity.id }, entity.toAttrs());
    }
    async saveManyInTransaction(entities) {
        await this.connection.transaction(async (manager) => {
            const updates = entities.map((e) => manager.update(EnergyTransferRequest_entity_1.EnergyTransferRequestEntity, { id: e.id }, e.toAttrs()));
            await Promise.all(updates);
        });
    }
    async createNew(command) {
        const entity = this.repository.create(EnergyTransferRequest_1.EnergyTransferRequest.newAttributes(command));
        const savedEntity = await this.repository.save(entity);
        return EnergyTransferRequest_1.EnergyTransferRequest.fromAttrs(savedEntity);
    }
    async findAll() {
        const results = await this.repository.find();
        return results.map(EnergyTransferRequest_1.EnergyTransferRequest.fromAttrs);
    }
    async findByCertificateId(certificateId) {
        const request = await this.repository.findOne({ certificateId });
        return request ? EnergyTransferRequest_1.EnergyTransferRequest.fromAttrs(request) : null;
    }
    async findById(id) {
        const request = await this.repository.findOne(id);
        return request ? EnergyTransferRequest_1.EnergyTransferRequest.fromAttrs(request) : null;
    }
    async findByState(state, options) {
        const results = await this.repository.find({
            where: { state },
            take: options.limit
        });
        return results.map(EnergyTransferRequest_1.EnergyTransferRequest.fromAttrs);
    }
    async updateWithLock(id, cb) {
        const queryRunner = this.connection.createQueryRunner();
        await queryRunner.startTransaction();
        try {
            const [rawRequest] = await queryRunner.query(`
                SELECT * FROM ${EnergyTransferRequest_entity_1.tableName}
                WHERE id = $1
                FOR UPDATE
            `, [id]);
            if (!rawRequest) {
                return;
            }
            const request = EnergyTransferRequest_1.EnergyTransferRequest.fromAttrs({
                ...rawRequest,
                certificateData: JSON.parse(rawRequest.certificateData),
                validationStatusRecord: JSON.parse(rawRequest.validationStatusRecord)
            });
            cb(request);
            const updateQuery = this.connection
                .createQueryBuilder()
                .update(EnergyTransferRequest_entity_1.EnergyTransferRequestEntity)
                .set(request.toAttrs())
                .where({ id: request.id })
                .getQueryAndParameters();
            await queryRunner.query(updateQuery[0], updateQuery[1]);
            await queryRunner.commitTransaction();
        }
        catch (e) {
            await queryRunner.rollbackTransaction();
            throw e;
        }
        finally {
            await queryRunner.release();
        }
    }
};
EnergyTransferRequestPostgresRepository = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(EnergyTransferRequest_entity_1.EnergyTransferRequestEntity)),
    __param(1, typeorm_1.InjectConnection()),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Connection])
], EnergyTransferRequestPostgresRepository);
exports.EnergyTransferRequestPostgresRepository = EnergyTransferRequestPostgresRepository;
//# sourceMappingURL=EnergyTransferRequestPostgres.repository.js.map